#if !defined(GLOBAL)
#define GLOBAL

/////////////////////////////////////////////////////////////////////////////
// Fonctions globales

void MakeBase(gp_Mat &R)
{
	//3eme colonne = nouvelle orientation
	//on projete 1ere et 2eme col sur plan perpendiculaire a 3eme col

	gp_Mat I;
	I.SetIdentity();
	gp_Mat nnt;
	double nx, ny, nz;
	nx=R(1,3);
	ny=R(2,3);
	nz=R(3,3);

	nnt(1,1)=nx*nx;
	nnt(2,2)=ny*ny;
	nnt(3,3)=nz*nz;
	nnt(2,1)=nnt(1,2)=nx*ny;
	nnt(3,1)=nnt(1,3)=nx*nz;
	nnt(3,2)=nnt(2,3)=ny*nz;
	
	gp_Mat proj=I-nnt;

	for (int i=1 ; i<=2 ; i++)
	{
		gp_XYZ myCol=R.Column(i);
		myCol=proj*myCol;
		myCol.Normalize();
		R.SetCol(i, myCol);
	}
}

void MakeBase(gp_Mat &R, gp_XYZ &o)
{
	//3eme colonne = nouvelle orientation
	//on projete X et Y col sur plan perpendiculaire a 3eme col

	gp_Mat I;
	I.SetIdentity();
	R.SetIdentity();
	gp_Mat nnt;
	R(1,3)=o.X();
	R(2,3)=o.Y();
	R(3,3)=o.Z();

	nnt(1,1)=o.X()*o.X();
	nnt(2,2)=o.Y()*o.Y();
	nnt(3,3)=o.Z()*o.Z();
	nnt(2,1)=nnt(1,2)=o.X()*o.Y();
	nnt(3,1)=nnt(1,3)=o.X()*o.Z();
	nnt(3,2)=nnt(2,3)=o.Y()*o.Z();
	
	gp_Mat proj=I-nnt;

	for (int i=1 ; i<=2 ; i++)
	{
		gp_XYZ myCol=R.Column(i);
		myCol=proj*myCol;
		myCol.Normalize();
		R.SetCol(i, myCol);
	}
}

CString DisplayMatrix(CString name, math_Matrix &M)
{
	int i,j;
	CString text2;
	CString text=name;
	text+="\n\r";

	for (i=M.LowerRow() ; i<=M.UpperRow() ; i++)
	{	
		for (j=M.LowerCol() ; j<=M.UpperCol() ; j++)
		{	
			text2.Format("%g\t", M(i,j));
			text+=text2;
		}
		text+="\n\r";
	}
	return text;
}

CString DisplayVector(CString name, gp_XYZ &V)
{
	CString text;
	text.Format("%s : %g\t%g\t%g", name, V.X(), V.Y(), V.Z());
	return text;
}

CString DisplayTheta()
{
	CString text;
	text.Format("theta : C=%g\tA=%g\tX=%g\tY=%g\tZ=%g", theta(1),theta(2),theta(3),theta(4),theta(5));
	return text;
}

#endif