// LeftView.cpp : implementation file
//

#include "stdafx.h"
#include "LeftView.h"
#include "Matsuura.h"
#include "Matsuuraview.h"
#include "mainfrm.h"
#include "aisdialogs.h"
#include "PointDlg.h"


#ifdef _DEBUG
//#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLeftView

IMPLEMENT_DYNCREATE(CLeftView, CTreeView)

CLeftView::CLeftView()
{
}

CLeftView::~CLeftView()
{
}


BEGIN_MESSAGE_MAP(CLeftView, CTreeView)
	//{{AFX_MSG_MAP(CLeftView)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_TREE_EDIT, OnTreeEdit)
	ON_COMMAND(ID_TREE_REACHPOINT, OnTreeReachpoint)
	ON_COMMAND(ID_TREE_SHOW, OnTreeShow)
	ON_COMMAND(ID_TREE_HIDE, OnTreeHide)
	ON_COMMAND(ID_TREE_DELETE, OnTreeDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CLeftView diagnostics

#ifdef _DEBUG
void CLeftView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CLeftView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLeftView message handlers

BOOL CLeftView::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |=(TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS);

	return CTreeView::PreCreateWindow(cs);
}

void CLeftView::OnInitialUpdate() 
{
	CTreeView::OnInitialUpdate();
}

void CLeftView::FillTree()
{
	int i;
	CMatsuuraDoc *pDoc=(CMatsuuraDoc*)GetDocument();
	CTreeCtrl &tree=GetTreeCtrl();

	tree.DeleteAllItems ();
	tree.InsertItem("Start");
	tree.InsertItem("Face");

	HTREEITEM h=tree.GetRootItem();
	h=tree.GetNextItem(h, TVGN_NEXT); 
	for (i=1 ; i<=pDoc->Path.GetNbEdge() ; i++)
	{
		CString text;
		text.Format("Edge%d", i);
		tree.InsertItem(text,h);
	}
	tree.InsertItem("End");
	tree.Expand(h, TVE_EXPAND);
}

void CLeftView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	FillTree();
}


void CLeftView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
  CMenu menu;
  VERIFY(menu.LoadMenu(IDR_PopupTree));
  CMenu* pPopup = menu.GetSubMenu(0);

  ASSERT(pPopup != NULL);

  pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON , point.x, point.y , this);
}


void CLeftView::OnTreeEdit() 
{
	CMatsuuraDoc *pDoc=(CMatsuuraDoc*)GetDocument();
	CTreeCtrl &tree=GetTreeCtrl();
	CString text=tree.GetItemText (tree.GetSelectedItem ());
		
	if (text=="Start")
	{
		gp_Pnt &p=pDoc->Path.StartPnt;
		gp_Dir &o=pDoc->Path.StartDir;
		CPointDlg dlg;
		dlg.Set(p,o);
		if (dlg.DoModal()==IDOK)
		{
			p.SetCoord(dlg.m_Px, dlg.m_Py, dlg.m_Pz);
			//o est normee dans SetCoord
			o.SetCoord(dlg.m_Ox, dlg.m_Oy, dlg.m_Oz);
		}
	}
	else if (text=="End")
	{
		gp_Pnt &p=pDoc->Path.EndPnt;
		gp_Dir &o=pDoc->Path.EndDir;
		CPointDlg dlg;
		dlg.Set(p,o);
		if (dlg.DoModal()==IDOK)
		{
			p.SetCoord(dlg.m_Px, dlg.m_Py, dlg.m_Pz);
			//o est normee dans SetCoord
			o.SetXYZ(gp_XYZ(dlg.m_Ox, dlg.m_Oy, dlg.m_Oz));
		}
	}
}

void CLeftView::OnTreeReachpoint() 
{
	CMatsuuraDoc *pDoc=(CMatsuuraDoc*)GetDocument();
	CTreeCtrl &tree=GetTreeCtrl();
	CString text=tree.GetItemText (tree.GetSelectedItem ());
	
	if (text=="Start")
		pDoc->ReachPoint(pDoc->Path.StartPnt, pDoc->Path.StartDir);
	else if (text=="End")
		pDoc->ReachPoint(pDoc->Path.EndPnt, pDoc->Path.EndDir);
}

void CLeftView::OnTreeShow() 
{
	CMatsuuraDoc *pDoc=(CMatsuuraDoc*)GetDocument();
	CTreeCtrl &tree=GetTreeCtrl();
	CString text=tree.GetItemText (tree.GetSelectedItem ());
		
	if (text=="Start" || text=="End")
	{
		Handle_Geom_Point p;
		
		if (text=="Start")
			p = new Geom_CartesianPoint(pDoc->Path.StartPnt);
		else
			p = new Geom_CartesianPoint(pDoc->Path.EndPnt);

		Handle_AIS_InteractiveObject AISp = new AIS_Point(p);

		pDoc->GetAISContext()->Display(AISp);
		pDoc->GetAISContext()->KeepTemporary(AISp);
	}
	else if (text.Find("Edge")!=-1)
	{
		int n=atoi(LPCSTR(text.Right(text.GetLength()-text.ReverseFind('e')-1)));
		Handle_AIS_Shape S = new AIS_Shape(pDoc->Path.ArrayOfEdge.Value(n));
		gp_Trsf T=pDoc->Part.GetAxis();
		pDoc->GetAISContext()->SetLocation(S, T);
		pDoc->GetAISContext()->Display(S);
		pDoc->GetAISContext()->Hilight(S);
		pDoc->GetAISContext()->Unhilight(S);
	}
}

void CLeftView::OnTreeHide() 
{
	AIS_ListOfInteractive aListOfIO;
	AIS_ListIteratorOfListOfInteractive anIterator;

	CMatsuuraDoc *pDoc=(CMatsuuraDoc*)GetDocument();
	CTreeCtrl &tree=GetTreeCtrl();
	CString text=tree.GetItemText (tree.GetSelectedItem ());
		
	if ((text=="Start") || (text=="End"))
	{
		gp_Pnt P1;
		if (text=="Start")
			P1=pDoc->Path.StartPnt;
		else
			P1=pDoc->Path.EndPnt;

		//on ne considere que les donnees et que les points (type=1) parmi les donnees
		pDoc->GetAISContext()->DisplayedObjects(AIS_KOI_Datum, 1, aListOfIO);

		for (anIterator.Initialize(aListOfIO) ; anIterator.More() ; anIterator.Next())
		{
			Handle_AIS_Point aAISPoint = Handle(AIS_Point)::DownCast(anIterator.Value());
			TopoDS_Vertex V=aAISPoint->Vertex();
			gp_Pnt P2(BRep_Tool::Pnt(V));

			if (P1.IsEqual(P2, 1e-5))
			{
				pDoc->GetAISContext()->Erase(anIterator.Value());
				return;
			}
		}
	}
}

void CLeftView::OnTreeDelete() 
{
	CMatsuuraDoc *pDoc=(CMatsuuraDoc*)GetDocument();
	CTreeCtrl &tree=GetTreeCtrl();
	CString text=tree.GetItemText (tree.GetSelectedItem ());
		
	if ((text=="Start") || (text=="End"))
		AfxMessageBox("Can't delete the Starting Point or the Ending Point !", MB_ICONSTOP);
	else if (text.Find("Edge")!=-1)
	{
		int n=atoi(LPCSTR(text.Right(text.GetLength()-text.ReverseFind('e')-1)));
		Handle_AIS_Shape S = new AIS_Shape(pDoc->Path.ArrayOfEdge.Value(n));
		gp_Trsf T=pDoc->Part.GetAxis();
		pDoc->GetAISContext()->SetLocation(S, T);
		pDoc->GetAISContext()->Display(S);
		pDoc->GetAISContext()->Hilight(S);
		pDoc->GetAISContext()->Unhilight(S);
		//utilisation de TopTools_SequenceOfShape car CArray::RemoveAt ne compile pas !
		pDoc->Path.ArrayOfEdge.Remove(n);
		FillTree();
	}
	else if (text=="Face")
	{
		pDoc->Path.ArrayOfEdge.Clear();
		FillTree();
	}
}

