// Matsuura.cpp : Defines the class behaviors for the application.
//

#include "StdAfx.h"
#include "Matsuura.h"

#include "MainFrm.h"
#include "MatsuuraDoc.h"
#include "MatsuuraView.h"

#ifdef _DEBUG
// CasCade :
//#define new DEBUG_NEW
// End CasCade

#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatsuuraApp

BEGIN_MESSAGE_MAP(CMatsuuraApp, CWinApp)
	//{{AFX_MSG_MAP(CMatsuuraApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatsuuraApp construction

CMatsuuraApp::CMatsuuraApp()
{
	try
	{
		myGraphicDevice = new Graphic3d_WNTGraphicDevice();
	}
	catch (Standard_Failure)
	{
		AfxMessageBox("Fatal Error in graphic initialisation");
	}

	// Set the local system units
	try
	{
		UnitsAPI::SetLocalSystem(UnitsAPI_MDTV);
	}
	catch (Standard_Failure)
	{
		AfxMessageBox("Fatal Error in units initialisation");
	}
}

CMatsuuraApp::~CMatsuuraApp()
{
// Warning : delete only template you don't declare by AddDocTemplate
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMatsuuraApp object

CMatsuuraApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMatsuuraApp initialization
BOOL CMatsuuraApp::InitInstance()
{
#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)
	
	//pour le controle MSFlexGrid
	AfxEnableControlContainer();

	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CMatsuuraDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CMatsuuraView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW/*MAXIMIZED*/);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMatsuuraApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMatsuuraApp commands
CMatsuuraDoc* CMatsuuraApp::GetDocument()
{
	POSITION pos = pDocTemplate->GetFirstDocPosition();
	return (CMatsuuraDoc *) pDocTemplate->GetNextDoc(pos);
}




