// MatsuuraDoc.cpp : implementation of the CMatsuuraDoc class
//

#include "StdAfx.h"
#include "mainfrm.h"
#include "leftview.h"
#include "Matsuura.h"

#include "MatsuuraDoc.h"
#include "MatsuuraView.h"

#include "AISDialogs.h"

#ifdef _DEBUG
//#define new DEBUG_NEW  // by cascade
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char* GetAppPath()
{
	CString path;
	path=AfxGetApp()->m_pszHelpFilePath;
	path=path.Left(path.ReverseFind ('\\')+1);
//	return LPSTR(path);
	char str[1024];
	strcpy(str, LPCSTR(path));
//	::GetCurrentDirectory(1024, str);
	return str;
};


/////////////////////////////////////////////////////////////////////////////
// CMatsuuraDoc

IMPLEMENT_DYNCREATE(CMatsuuraDoc, CDocument)

BEGIN_MESSAGE_MAP(CMatsuuraDoc, CDocument)
	//{{AFX_MSG_MAP(CMatsuuraDoc)
	ON_COMMAND(ID_OBJECT_COLOR, OnObjectColor)
	ON_UPDATE_COMMAND_UI(ID_OBJECT_COLOR, OnUpdateObjectColor)
	ON_COMMAND(ID_OBJECT_SHADING, OnObjectShading)
	ON_UPDATE_COMMAND_UI(ID_OBJECT_SHADING, OnUpdateObjectShading)
	ON_COMMAND(ID_OBJECT_WIREFRAME, OnObjectWireframe)
	ON_UPDATE_COMMAND_UI(ID_OBJECT_WIREFRAME, OnUpdateObjectWireframe)
	ON_COMMAND(ID_OBJECT_TRANPARENCY, OnObjectTransparency)
	ON_UPDATE_COMMAND_UI(ID_OBJECT_TRANPARENCY, OnUpdateObjectTransparency)
	ON_COMMAND(ID_FILE_EXPORTIMAGE, OnFileExportimage)
	ON_COMMAND(ID_SIMULATION_OPTIONS, OnSimulationOptions)
	ON_COMMAND(ID_SIMULATION_ITERATION, OnSimulationIteration)
	ON_COMMAND(ID_PATH_ADD_SIMPLE_FACE, OnPathAddSimpleFace)
	ON_COMMAND(ID_PATH_ADD_COMPLEX_FACE, OnPathAddComplexFace)
	ON_COMMAND(ID_SIMULATION_COMPUTESIMULATION, OnSimulationComputesimulation)
	ON_COMMAND(ID_SIMULATION_RUNSIMULATION, OnSimulationRunsimulation)
	ON_COMMAND(ID_SIMULATION_SAVE_CARTESIAN, OnSimulationSaveCartesian)
	ON_COMMAND(ID_SIMULATION_SAVE_INVERSE, OnSimulationSaveInverse)
	//}}AFX_MSG_MAP

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatsuuraDoc construction/destruction

CMatsuuraView* CMatsuuraDoc::Get3dView()
{
	return ((CMainFrame*)AfxGetMainWnd())->GetRightPane();
}

CLeftView* CMatsuuraDoc::GetTreeView()
{
	return ((CMainFrame*)AfxGetMainWnd())->GetLeftPane();
}


CMatsuuraDoc::CMatsuuraDoc()
{
	Handle(Graphic3d_WNTGraphicDevice) theGraphicDevice = 
		((CMatsuuraApp*)AfxGetApp())->GetGraphicDevice();
	myViewer = new V3d_Viewer(theGraphicDevice,(short *) "Visu3D");
	myViewer->SetDefaultLights();
	myViewer->SetLightOn();
	myAISContext =new AIS_InteractiveContext(myViewer);

	A_Coord=NULL;
	C_Coord=NULL;
}

CMatsuuraDoc::~CMatsuuraDoc()
{
	FreeCoord();
}

void CMatsuuraDoc::FreeCoord()
{
	if(A_Coord)
	{
		for (int i=0 ; i<nb_Coord && A_Coord[i] ; i++)
			delete A_Coord[i];
		delete A_Coord;
		A_Coord=NULL;
	}

	if(C_Coord)
	{
		for (int i=0 ; i<nb_Coord && A_Coord[i] ; i++)
			delete C_Coord[i];
		delete C_Coord;
		C_Coord=NULL;
	}
}

BOOL CMatsuuraDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument()) 
		return FALSE;

	myAISContext->EraseAll(Standard_False);
	
	nb_Coord=0;
	precision=1e-3;
	discret=25;
	max_iter=500;
	CurPath=0;
	SurfType=SIMPLE_FACE;
	CurMethod=RMR_METHOD;
	computed=false;
//	Path.SetSize(1);
	
	FreeCoord();

	BRep_Builder B;
	TopoDS_Shape S1, S2, S3, S4, S5;

	char AppPath[1024];
	strcpy(AppPath, GetAppPath());
	char Name[1024];

	strcpy(Name, AppPath);
	strcat(Name,"\\Machine\\Frame.brep");
	BRepTools::Read(S1,Name,B);
	strcpy(Name, AppPath);
	strcat(Name,"\\Machine\\Table_XY.brep");
	BRepTools::Read(S2,Name,B);
	strcpy(Name, AppPath);
	strcat(Name,"\\Machine\\Table_Z.brep");
	BRepTools::Read(S3,Name,B);
	strcpy(Name, AppPath);
	strcat(Name,"\\Machine\\Table_A.brep");
	BRepTools::Read(S4,Name,B);
	strcpy(Name, AppPath);
	strcat(Name,"\\Machine\\Table_C.brep");
	BRepTools::Read(S5,Name,B);

	if (S1.IsNull() || S2.IsNull() || S3.IsNull() || S4.IsNull() || S5.IsNull())
		AfxMessageBox("Shape(s) not found.\nCheck the Machine directory path!", MB_ICONERROR);
	else
	{
		gp_Trsf T;

		T.SetTranslation(gp_Vec(0,150,50+Tool.GetLength()));
		Table_Z.SetContext(myAISContext);
		Table_Z.SetShape(S3);
		Table_Z.SetColor(Quantity_NOC_GREEN);
		Table_Z.SetMaterial(Graphic3d_NOM_PLASTIC);
		Table_Z.SetTrsf(T);
		Table_Z.Display();

		T.SetTranslation(gp_Vec(0,0,-36.96));
		Table_C.SetContext(myAISContext);
		Table_C.SetShape(S5);
		Table_C.SetColor(Quantity_NOC_BLUE1);
		Table_C.SetMaterial(Graphic3d_NOM_PLASTIC);
		Table_C.SetTrsf(T);
		Table_C.Display();

		T.SetTranslation(gp_Vec(0,0,-136.96));
		Table_A.SetContext(myAISContext);
		Table_A.SetShape(S4);
		Table_A.SetColor(Quantity_NOC_ORANGE);
		Table_A.SetMaterial(Graphic3d_NOM_PLASTIC);
		Table_A.SetTrsf(T);
		Table_A.Display();

		T.SetTranslation(gp_Vec(0,0,-596.96));
		Table_XY.SetContext(myAISContext);
		Table_XY.SetShape(S2);
		Table_XY.SetColor(Quantity_NOC_YELLOW);
		Table_XY.SetMaterial(Graphic3d_NOM_PLASTIC);
		Table_XY.SetTrsf(T);
		Table_XY.Display();

		Frame.SetContext(myAISContext);
		Frame.SetShape(S1);
		Frame.SetColor(Quantity_NOC_GREEN4);
		Frame.SetMaterial(Graphic3d_NOM_PLASTIC);
		Frame.SetTrsf(T);
		Frame.Display();

		Tool.CreateShape();
		Tool.SetContext(myAISContext);
		Tool.SetColor(Quantity_NOC_WHITE);
		Tool.SetMaterial(Graphic3d_NOM_PLASTIC);
		Tool.Display();
	}
	return TRUE;
}

void CMatsuuraDoc::Serialize(CArchive& ar)
{
	if (ar.IsLoading())
	{
		BRep_Builder B;
		TopoDS_Shape S;
		
		BRepTools::Read(S,(Standard_CString)(LPCSTR)ar.GetFile()->GetFilePath(),B);
	
		Part.SetContext(myAISContext);
		Part.SetShape(S);
		Part.SetColor(Quantity_NOC_RED);
		Part.SetMaterial(Graphic3d_NOM_PLASTIC);
		Part.Display();
	}
}

void CMatsuuraDoc::OnFileExportimage()
{
  CFileDialog dlg(FALSE,_T("*.BMP"),NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                  _T("BMP Files (*.BMP)|*.bmp |GIF Files (*.GIF)|*.gif | XWD Files (*.XWD)|*.xwd||"), 
                  NULL );

  if (dlg.DoModal() == IDOK) 
  {
	CWaitCursor c;
	CString filename = dlg.GetPathName();
    Handle(Aspect_Window) anAspectWindow = Get3dView()->GetView()->Window();
    Handle(WNT_Window) aWNTWindow = Handle(WNT_Window)::DownCast(anAspectWindow);
    CString ext = dlg.GetFileExt();
    if (ext == "bmp")     aWNTWindow->SetOutputFormat ( WNT_TOI_BMP );
    if (ext == "gif")     aWNTWindow->SetOutputFormat ( WNT_TOI_GIF );
    if (ext == "xwd")     aWNTWindow->SetOutputFormat ( WNT_TOI_XWD );
    aWNTWindow->Dump ((Standard_CString)(LPCTSTR)filename);
  }
}

void CMatsuuraDoc::OnSimulationOptions() 
{
	COptions dlg(CurMethod);

	dlg.m_Precision = precision;
	dlg.m_Discret = discret;
	dlg.m_MaxIter = max_iter;
	dlg.m_Delay = Get3dView()->delay;

	if (dlg.DoModal()==IDOK)
	{
		precision=dlg.m_Precision;
		discret=dlg.m_Discret;
		max_iter=dlg.m_MaxIter;
		Get3dView()->delay=dlg.m_Delay;
		CurMethod=dlg.Method;
	}
}

void CMatsuuraDoc::OnSimulationIteration() 
{
	CString text;
	double min=1e10;
	double max=0;

	for (int i=0 ; i<Path.GetSize() ; i++)
	{
		min=MIN(min, Path[i].GetMinNbIteration());
		max=MAX(max, Path[i].GetMaxNbIteration());
	}
	text.Format("Minimum number of iterations : %d\nMaximum number of iterations : %d", min, max);
	AfxMessageBox(text);
}

void CMatsuuraDoc::AddComplexFace(TopoDS_Face &F)
{
//	CurPath=Path.GetSize();
/*	Path.SetSize(CurPath+1);
	Path[CurPath].SetFace(F);
	Path[CurPath].SetTool(Tool);
*/
	Path.SetFace(F);
	Path.SetTool(Tool);
	UpdateAllViews(((CMainFrame*)AfxGetMainWnd())->GetRightPane());
}

void CMatsuuraDoc::AddComplexEdge(TopoDS_Edge &E)
{
	Path[CurPath].AddEdge(E);
	UpdateAllViews(((CMainFrame*)AfxGetMainWnd())->GetRightPane());
}

void CMatsuuraDoc::AddSimpleFace(TopoDS_Face &F)
{
/*	CurPath=Path.GetSize();
	Path.SetSize(CurPath+1);
	Path[CurPath].SetFace(F);
	Path[CurPath].ComputeEdge();
	Path[CurPath].SetTool(Tool);*/
	Path.SetFace(F);
	Path.ComputeEdge();
	Path.SetTool(Tool);
	UpdateAllViews(((CMainFrame*)AfxGetMainWnd())->GetRightPane());
}

/////////////////////////////////////////////////////////////////////////////
// CMatsuuraDoc diagnostics

#ifdef _DEBUG
void CMatsuuraDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMatsuuraDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMatsuuraDoc 3d viewer

void CMatsuuraDoc::OnObjectColor() 
{
	myAISContext->InitCurrent();
    Quantity_Color CSFColor = myAISContext->Color(myAISContext->Current());
    COLORREF MSColor = RGB (CSFColor.Red()*255.,CSFColor.Green()*255.,CSFColor.Blue()*255.);
	
	CColorDialog dlgColor(MSColor);
	if (dlgColor.DoModal() == IDOK)
	{
	  MSColor = dlgColor.GetColor();
	  CSFColor = Quantity_Color (GetRValue(MSColor)/255.,GetGValue(MSColor)/255.,
						         GetBValue(MSColor)/255.,Quantity_TOC_RGB); 
	  for (;myAISContext->MoreCurrent ();myAISContext->NextCurrent ())
		  myAISContext->SetColor (myAISContext->Current(),CSFColor.Name());
	}
}
void CMatsuuraDoc::OnUpdateObjectColor(CCmdUI* pCmdUI) 
{
    myAISContext->InitCurrent();
	pCmdUI->Enable (myAISContext->MoreCurrent ());	
}

void CMatsuuraDoc::OnObjectWireframe() 
{
  for(myAISContext->InitCurrent();myAISContext->MoreCurrent();myAISContext->NextCurrent())
        myAISContext->SetDisplayMode(myAISContext->Current(),0);
}
void CMatsuuraDoc::OnUpdateObjectWireframe(CCmdUI* pCmdUI) 
{
  bool OneOrMoreInShading = Standard_False;
  for (myAISContext->InitCurrent();myAISContext->MoreCurrent ();myAISContext->NextCurrent ())
    if (myAISContext->IsDisplayed(myAISContext->Current(),1)) OneOrMoreInShading=Standard_True;
	pCmdUI->Enable (OneOrMoreInShading);	
}

void CMatsuuraDoc::OnObjectShading() 
{
  CWaitCursor aWaitCursor;
  for(myAISContext->InitCurrent();myAISContext->MoreCurrent();myAISContext->NextCurrent())
      myAISContext->SetDisplayMode(myAISContext->Current(),1);
}

void CMatsuuraDoc::OnUpdateObjectShading(CCmdUI* pCmdUI) 
{
  bool OneOrMoreInWireframe = Standard_False;
  for (myAISContext->InitCurrent();myAISContext->MoreCurrent ();myAISContext->NextCurrent ())
    if (myAISContext->IsDisplayed(myAISContext->Current(),0)) OneOrMoreInWireframe=Standard_True;
	pCmdUI->Enable (OneOrMoreInWireframe);	
}

void CMatsuuraDoc::OnObjectTransparency()
{
	CDialogTransparency DialBox(myAISContext);
	DialBox.DoModal();	
}

void CMatsuuraDoc::OnUpdateObjectTransparency(CCmdUI* pCmdUI) 
{
  bool OneOrMoreInShading = Standard_False;
  for (myAISContext->InitCurrent();myAISContext->MoreCurrent ();myAISContext->NextCurrent ())
    if (myAISContext->IsDisplayed(myAISContext->Current(),1)) OneOrMoreInShading=Standard_True;
	pCmdUI->Enable (OneOrMoreInShading);	
}

/////////////////////////////////////////////////////////////////////////////
// CMatsuuraDoc robotique

void CMatsuuraDoc::DrawStep(double X, double Y, double Z, double A, double C)
{
	double Ca, Sa, Cc, Sc;
	double l=Tool.GetLength();

	Ca=cos(A*PI/180);
	Sa=sin(A*PI/180);
	Cc=cos(C*PI/180);
	Sc=sin(C*PI/180);

	
	Tool.Transform(	1,	0,	0,	0,
					0,	1,	0,	0,
					0,	0,	1,	Z+d-l);
	Table_Z.Transform(	1,	0,	0,	0,
						0,	1,	0,	0,
						0,	0,	1,	Z+d-l);

	Part.Transform(	Cc,		-Sc,	0,		X,
					Ca*Sc,	Ca*Cc,	-Sa,	-Sa*d+Y,
					Sa*Sc,	Sa*Cc,	Ca,		Ca*d);

	Table_C.Transform(	Cc,		-Sc,	0,		X,
					Ca*Sc,	Ca*Cc,	-Sa,	-Sa*d+Y,
					Sa*Sc,	Sa*Cc,	Ca,		Ca*d);

	Table_A.Transform(	1,	0,	0,		X,
						0,	Ca,	-Sa,	-Sa*d+Y,
						0,	Sa,	Ca,		Ca*d);
	Table_XY.Transform(	1,	0,	0,	X,
						0,	1,	0,	Y,
						0,	0,	1,	0);

	myAISContext->UpdateCurrentViewer();
}


/////////////////////////////////////////////////////////////////////////////
// CMatsuuraDoc interface

void CMatsuuraDoc::OnStep() 
{
	double X, Y, Z, A, C;
	
	if (NumCurPos > nb_Coord-1)
		NumCurPos=0;
	else if (NumCurPos < 0)
		NumCurPos=nb_Coord-1;

	X=A_Coord[NumCurPos][0];
	Y=A_Coord[NumCurPos][1];
	Z=A_Coord[NumCurPos][2];
	A=A_Coord[NumCurPos][3];
	C=A_Coord[NumCurPos][4];
	
	DrawStep(X, Y, Z, A, C);
}

void CMatsuuraDoc::OnPathAddSimpleFace() 
{
	Path.RemoveAll();
	myAISContext->CloseLocalContext();
	myAISContext->OpenLocalContext();
	myAISContext->ActivateStandardMode(TopAbs_FACE);
	SurfType=SIMPLE_FACE;
}

void CMatsuuraDoc::OnPathAddComplexFace() 
{
	Path.RemoveAll();
	myAISContext->CloseLocalContext();
	myAISContext->OpenLocalContext();
	myAISContext->ActivateStandardMode(TopAbs_FACE);
	SurfType=COMPLEX_FACE;
}

void CMatsuuraDoc::OnSimulationComputesimulation() 
{
	int i,j,k, index=0;
	int length;

	myAISContext->CloseLocalContext();

//	length=Path.GetSize();
	nb_Coord=Path.GetNbPoint();

/*	nb_Coord=0;
	for (i=0 ; i<length ; i++)
	{
		Path[i].SetDiscretisation(discret);
		Path[i].SetPrecision(precision);
		Path[i].SetMaxIter(max_iter);
		Path[i].ArrayOfPoint.RemoveAll();
		Path[i].ArrayOfNormal.RemoveAll();
		Path[i].ComputePointAndNormal();
		nb_Coord+=Path[i].GetNbPoint();
	}*/

	FreeCoord();

	A_Coord = new double*[nb_Coord];
	C_Coord = new double*[nb_Coord];

	for(i=0  ;i<Path.GetSize() ; i++, index++)
	{
		if (CurMethod==RMR_METHOD)
			Path[i].RMR();
		else
			Path[i].MGI();

		for (j=0 ; j<Path[i].GetNbPoint() ; j++, index++)
		{
			A_Coord[index] = new double[NB_JOINT];
			C_Coord[index] = new double[6];
			for (k=0 ; k<NB_JOINT ; k++)
				A_Coord[index][k]=Path[i].A_Coord[j][k];
			C_Coord[index][0]=Path[i].ArrayOfPoint[j].X();
			C_Coord[index][1]=Path[i].ArrayOfPoint[j].Y();
			C_Coord[index][2]=Path[i].ArrayOfPoint[j].Z();
			C_Coord[index][3]=Path[i].ArrayOfNormal[j].X();
			C_Coord[index][4]=Path[i].ArrayOfNormal[j].Y();
			C_Coord[index][5]=Path[i].ArrayOfNormal[j].Z();
		}
	}
	computed=true;
}

void CMatsuuraDoc::OnSimulationRunsimulation() 
{
	CFileDialog dlg(true);
	if (dlg.DoModal()==IDOK)
	{
		NumCurPos=0;
		ReadA_File(dlg.GetPathName());
	}
}

bool CMatsuuraDoc::ReadA_File(CString &text)
{
	fstream f;
	int i, j;

	f.clear();
	f.open(LPCSTR(text), ios::in);
	if (f.fail ())
		return false;
	
	FreeCoord();

	f >> nb_Coord;

	A_Coord = new double*[nb_Coord];

	for (i=0 ; i<nb_Coord ; i++)
	{
		A_Coord[i] = new double[NB_JOINT];
		for (j=0 ; j<NB_JOINT ; j++)
			f >> A_Coord[i][j];
	}
	f.close();
	return true;
}


bool CMatsuuraDoc::OnSimulationSaveCartesian() 
{
	ofstream f;
	int i, j;
	CString text;
	CFileDialog dlg(false);

	if (dlg.DoModal()==IDOK)
	{
		f.clear();
		f.open(LPCSTR(dlg.GetPathName()));
		if (f.fail ())
			return false;

		for(i=0  ;i<Path.GetSize() ; i++)
		{
			Path[i].SetDiscretisation(discret);
			Path[i].ArrayOfPoint.RemoveAll();
			Path[i].ArrayOfNormal.RemoveAll();
			Path[i].ComputePointAndNormal();
			for (j=0 ; j<Path[i].GetNbPoint() ; j++)
			{
				f<<Path[i].ArrayOfPoint[j].X()<<"\t";
				f<<Path[i].ArrayOfPoint[j].Y()<<"\t";
				f<<Path[i].ArrayOfPoint[j].Z()<<"\t";
				f<<Path[i].ArrayOfNormal[j].X()<<"\t";
				f<<Path[i].ArrayOfNormal[j].Y()<<"\t";
				f<<Path[i].ArrayOfNormal[j].Z()<<"\t";
				f<<endl;
			}
		}
		f.close();
		return true;
	}
	return false;
}
bool CMatsuuraDoc::OnSimulationSaveInverse() 
{
	ofstream f;
	int i;
	CString text;
	CFileDialog dlg(false);

	if (computed)
	{
		if (dlg.DoModal()==IDOK)
		{
			f.clear();
			f.open(LPCSTR(dlg.GetPathName()));
			if (f.fail ())
				return false;
	
			f << nb_Coord <<endl;

			for (i=0 ; i<nb_Coord ; i++)
				f<<A_Coord[i][0]<<"\t"<<A_Coord[i][1]<<"\t"<<A_Coord[i][2]<<"\t"<<A_Coord[i][3]<<"\t"<<A_Coord[i][4]<< endl;
			f.close();
			return true;
		}
	}
	else
		AfxMessageBox("Compute simulation first !", MB_ICONSTOP);

	return false;
}

void CMatsuuraDoc::ReachPoint(gp_Pnt &p, gp_Dir &o) 
{
	double X, Y, Z, A, C;

	Path[0].MGI(p, o, X, Y, Z, A, C);
	DrawStep(X, Y, Z, A, C);
}
