// MatsuuraMachine.cpp: implementation of the MatsuuraMachine class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "matsuura.h"
#include "MatsuuraMachine.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MatsuuraMachine::MatsuuraMachine()
{
	Tool = new MatsuuraTool;
	d=3.5418*INCH;
	Amin=-15;
	Amax=90;
	Cmin=-99999.999;
	Cmax=99999.999;
	Xmin=-17.8399*INCH;
	Xmax=12.1149*INCH;
	Ymin=-8.2799*INCH;
	Ymax=8.6322*INCH;
	Zmin=2.5*INCH;
	Zmax=20.2350*INCH;
	WFo=0.5;
	w0=0;
	MAD=15;

	for (int i=0 ; i<NB_JOINT ; i++)
		Weight[i]=0.0;
}

MatsuuraMachine::~MatsuuraMachine()
{

}

void MatsuuraMachine::Init()
{
	Frame.Init();
	Table_XY.Init();
	Table_Z.Init();
	Table_A.Init();
	Table_C.Init();
	Tool->Init();
}

void MatsuuraMachine::ComputeW0()
{
	w0=WFo*cos(MAD*PI/180);
}

void MatsuuraMachine::ComputeWeight()
{
	ComputeW0();
	Weight[0]=(1-WFo)/(NB_JOINT*(Cmax-Cmin)/4*(Cmax-Cmin)/4);
	Weight[1]=(1-WFo)/(NB_JOINT*(Amax-Amin)/4*(Amax-Amin)/4);
	Weight[2]=(1-WFo)/(NB_JOINT*(Xmax-Xmin)/4*(Xmax-Xmin)/4);
	Weight[3]=(1-WFo)/(NB_JOINT*(Ymax-Ymin)/4*(Ymax-Ymin)/4);
	Weight[4]=(1-WFo)/(NB_JOINT*(Zmax-Zmin)/4*(Zmax-Zmin)/4);
}