// MatsuuraMachine.h: interface for the MatsuuraMachine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MATSUURAMACHINE_H__BCFC380F_AC9C_4A4F_A529_F4B328A6E10C__INCLUDED_)
#define AFX_MATSUURAMACHINE_H__BCFC380F_AC9C_4A4F_A529_F4B328A6E10C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MatsuuraObject.h"
#include "MatsuuraTool.h"

class MatsuuraMachine  
{
public:
	MatsuuraMachine();
	virtual ~MatsuuraMachine();

	MatsuuraObject Frame;
	MatsuuraObject Table_XY;
	MatsuuraObject Table_Z;
	MatsuuraObject Table_A;
	MatsuuraObject Table_C;
	MatsuuraTool *Tool;

	//d est la distance entre axe X et axe A
	double Amin, Amax, Cmin, Cmax, Xmin, Xmax, Ymin, Ymax, Zmin, Zmax, d;

	//poids pour calcul avec critere d'optimalite
	double Weight[NB_JOINT];

	//pour critere d'optimisation
	double WFo;		//ponderation entre le poids affecte a l'orientation et le critere d'optimalite
	double w0;		//poids affecte a l'orientation
	double MAD;		//deviation angulaire maximale

public:
	void Init();
	double GetCmoy() {return (Cmin+Cmax)/2;};
	double GetAmoy() {return (Amin+Amax)/2;};
	double GetXmoy() {return (Xmin+Xmax)/2;};
	double GetYmoy() {return (Ymin+Ymax)/2;};
	double GetZmoy() {return (Zmin+Zmax)/2;};
	void ComputeW0();
	void ComputeWeight();
};

#endif // !defined(AFX_MATSUURAMACHINE_H__BCFC380F_AC9C_4A4F_A529_F4B328A6E10C__INCLUDED_)
