// MatsuuraObject.h: interface for the MatsuuraObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MATSUURAOBJECT_H__6688FFED_A251_490C_9A35_66B8FB938CF3__INCLUDED_)
#define AFX_MATSUURAOBJECT_H__6688FFED_A251_490C_9A35_66B8FB938CF3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"

#define PI 3.14159265359
#define NB_JOINT 5
#define INCH 25.4

class MatsuuraObject  
{
protected:
	TopoDS_Shape Shape;
	Handle_AIS_Shape AisShape;
	Handle_AIS_Trihedron Trihedron;
	gp_Trsf Trsf;		//position d'origine dans l'asemblage
	gp_Trsf Axis;		//position reelle
	Handle_AIS_InteractiveContext Context;

public:
	MatsuuraObject();
	virtual ~MatsuuraObject();
	
	void SetContext(Handle_AIS_InteractiveContext &C) {Context=C;};
	void SetColor(Quantity_NameOfColor aColor);
	void SetMaterial(Graphic3d_NameOfMaterial aName);
	void Display();
	void Erase();
	void Init();

	void SetShape(TopoDS_Shape S);
	TopoDS_Shape& GetShape() {return Shape;};
	Handle_AIS_Shape& GetAisShape() {return AisShape;};
	gp_Trsf& GetAxis() {return Axis;};

	void SetOrigin(gp_Pnt &p);
	void SetTrsf(	double r11, double r12, double r13, double t1,
					double r21, double r22, double r23, double t2,
					double r31, double r32, double r33, double t3);
	void SetTrsf(gp_Trsf &T);
	void Transform(	double r11, double r12, double r13, double t1,
					double r21, double r22, double r23, double t2,
					double r31, double r32, double r33, double t3);
	void Transform(gp_Trsf &T);
	gp_Trsf& GetTrsf() {return Trsf;};
};

#endif // !defined(AFX_MATSUURAOBJECT_H__6688FFED_A251_490C_9A35_66B8FB938CF3__INCLUDED_)
