// MatsuuraView.cpp : implementation of the CMatsuuraView3D class
//

#include "StdAfx.h"
#include "Matsuura.h"
#include "mainfrm.h"

#include "MatsuuraDoc.h"
#include "MatsuuraView.h"
#include "LeftView.h"

#ifdef _DEBUG
//#define new DEBUG_NEW by CasCade
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// for elastic bean selection
#define ValZWMin 1

// the key for multi selection :
#define MULTISELECTIONKEY MK_SHIFT

// the key for shortcut ( use to activate dynamic rotation, panning )
#define CASCADESHORTCUTKEY MK_CONTROL

// define in witch case you want to display the popup
#define POPUPONBUTTONDOWN


/////////////////////////////////////////////////////////////////////////////
// CMatsuuraView
IMPLEMENT_DYNCREATE(CMatsuuraView, CView)

BEGIN_MESSAGE_MAP(CMatsuuraView, CView)
	//{{AFX_MSG_MAP(CMatsuuraView)
	ON_COMMAND(ID_BUTTONAxo, OnBUTTONAxo)
	ON_COMMAND(ID_BUTTONBack, OnBUTTONBack)
	ON_COMMAND(ID_BUTTONBottom, OnBUTTONBottom)
	ON_COMMAND(ID_BUTTONFront, OnBUTTONFront)
	ON_COMMAND(ID_BUTTONLeft, OnBUTTONLeft)
	ON_COMMAND(ID_BUTTONPan, OnBUTTONPan)
	ON_COMMAND(ID_BUTTONPanGlo, OnBUTTONPanGlo)
	ON_COMMAND(ID_BUTTONReset, OnBUTTONReset)
	ON_COMMAND(ID_BUTTONRight, OnBUTTONRight)
	ON_COMMAND(ID_BUTTONRot, OnBUTTONRot)
	ON_COMMAND(ID_BUTTONTop, OnBUTTONTop)
	ON_COMMAND(ID_BUTTONZoomAll, OnBUTTONZoomAll)
	ON_WM_SIZE()
	ON_COMMAND(ID_BUTTONZoomProg, OnBUTTONZoomProg)
	ON_COMMAND(ID_BUTTONZoomWin, OnBUTTONZoomWin)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MBUTTONDOWN()
	ON_WM_MBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_UPDATE_COMMAND_UI(ID_BUTTONPanGlo, OnUpdateBUTTONPanGlo)
	ON_UPDATE_COMMAND_UI(ID_BUTTONPan, OnUpdateBUTTONPan)
	ON_UPDATE_COMMAND_UI(ID_BUTTONZoomProg, OnUpdateBUTTONZoomProg)
	ON_UPDATE_COMMAND_UI(ID_BUTTONZoomWin, OnUpdateBUTTONZoomWin)
	ON_UPDATE_COMMAND_UI(ID_BUTTONRot, OnUpdateBUTTONRot)
	ON_COMMAND(ID_Modify_ChangeBackground     , OnChangeBackground)
	ON_WM_TIMER()
	ON_COMMAND(ID_DOWN, OnDown)
	ON_COMMAND(ID_FIRST, OnFirst)
	ON_COMMAND(ID_LAST, OnLast)
	ON_COMMAND(ID_STOP, OnStop)
	ON_COMMAND(ID_UP, OnUp)
	ON_COMMAND(ID_PLAY_DOWN, OnPlayDown)
	ON_COMMAND(ID_PLAY_UP, OnPlayUp)
	ON_UPDATE_COMMAND_UI(ID_STOP, OnUpdateStop)
	ON_UPDATE_COMMAND_UI(ID_DOWN, OnUpdateDown)
	ON_UPDATE_COMMAND_UI(ID_FIRST, OnUpdateFirst)
	ON_UPDATE_COMMAND_UI(ID_LAST, OnUpdateLast)
	ON_UPDATE_COMMAND_UI(ID_PLAY_DOWN, OnUpdatePlayDown)
	ON_UPDATE_COMMAND_UI(ID_PLAY_UP, OnUpdatePlayUp)
	ON_UPDATE_COMMAND_UI(ID_UP, OnUpdateUp)

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatsuuraView construction/destruction

CMatsuuraView::CMatsuuraView()
{
	// TODO: add construction code here

    myXmin=0;
    myYmin=0;  
    myXmax=0;
    myYmax=0;
    myCurZoom=0;
	FirsTime = TRUE;

    // will be set in OnInitial update, but, for more security :
    myCurrentMode = CurAction3d_Nothing;
    myDegenerateModeIsOn=Standard_True;
    m_Pen = new CPen(PS_SOLID, 2, RGB(0,0,0));
	up=down=false;
	delay=20;
}

CMatsuuraView::~CMatsuuraView()
{
  myView->Remove();
  if (m_Pen) delete m_Pen;
}

BOOL CMatsuuraView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMatsuuraView drawing

void CMatsuuraView::OnDraw(CDC* pDC)
{
	CMatsuuraDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	myView->Redraw();
}

void CMatsuuraView::OnInitialUpdate() 
{
//	CView::OnInitialUpdate();
	// TODO: Add your specialized code here and/or call the base class
	    // TODO: Add your specialized code here and/or call the base class
	if (FirsTime == TRUE) {
	    myView = GetDocument()->GetViewer()->CreateView();

	    // store for restore state after rotation (witch is in Degenerated mode)
		myDegenerateModeIsOn = myView->DegenerateModeIsOn();

		Handle(Graphic3d_WNTGraphicDevice) theGraphicDevice = 
			((CMatsuuraApp*)AfxGetApp())->GetGraphicDevice();
    
		Handle(WNT_Window) aWNTWindow = new WNT_Window(theGraphicDevice,GetSafeHwnd ());
	    myView->SetWindow(aWNTWindow);
		if (!aWNTWindow->IsMapped()) aWNTWindow->Map();

		// store the mode ( nothing , dynamic zooming, dynamic ... )
		myCurrentMode = CurAction3d_Nothing;

		FirsTime = FALSE;
	}
}



/////////////////////////////////////////////////////////////////////////////
// CMatsuuraView diagnostics

#ifdef _DEBUG
void CMatsuuraView::AssertValid() const
{
	CView::AssertValid();
}

void CMatsuuraView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMatsuuraDoc* CMatsuuraView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMatsuuraDoc)));
	return (CMatsuuraDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMatsuuraView message handlers

void CMatsuuraView::OnSize(UINT nType, int cx, int cy) 
{
  if (!myView.IsNull())
   myView->MustBeResized();

}

void CMatsuuraView::OnBUTTONBack() 
{ myView->SetProj(V3d_Xneg); } // See the back View
void CMatsuuraView::OnBUTTONFront() 
{ myView->SetProj(V3d_Xpos); } // See the front View

void CMatsuuraView::OnBUTTONBottom() 
{ myView->SetProj(V3d_Zneg); } // See the bottom View
void CMatsuuraView::OnBUTTONTop() 
{ myView->SetProj(V3d_Zpos); } // See the top View	

void CMatsuuraView::OnBUTTONLeft() 
{ myView->SetProj(V3d_Ypos); } // See the left View	
void CMatsuuraView::OnBUTTONRight() 
{ myView->SetProj(V3d_Yneg); } // See the right View

void CMatsuuraView::OnBUTTONAxo() 
{ myView->SetProj(V3d_XposYnegZpos); } // See the axonometric View

void CMatsuuraView::OnBUTTONPan() 
{
    if(myCurrentMode == CurAction3d_DynamicPanning)
        myCurrentMode  = CurAction3d_Nothing;
    else myCurrentMode = CurAction3d_DynamicPanning;
}

void CMatsuuraView::OnBUTTONPanGlo() 
{
  // save the current zoom value 
  myCurZoom = myView->Scale();
  // Do a Global Zoom 
  myView->FitAll();
  // Set the mode 
  myCurrentMode = CurAction3d_GlobalPanning;
}

void CMatsuuraView::OnBUTTONReset() 
{   myView->Reset(); }

void CMatsuuraView::OnBUTTONRot() 
{
    if(myCurrentMode == CurAction3d_DynamicRotation)
        myCurrentMode  = CurAction3d_Nothing;
    else myCurrentMode = CurAction3d_DynamicRotation;
}


void CMatsuuraView::OnBUTTONZoomAll() 
{
  myView->FitAll();
  myView->ZFitAll();
}

void CMatsuuraView::OnBUTTONZoomProg() 
{ 
    if(myCurrentMode == CurAction3d_DynamicZooming)
        myCurrentMode  = CurAction3d_Nothing;
    else myCurrentMode = CurAction3d_DynamicZooming;
}

void CMatsuuraView::OnBUTTONZoomWin() 
{  myCurrentMode = CurAction3d_WindowZooming; }

void CMatsuuraView::OnLButtonDown(UINT nFlags, CPoint point) 
{
    // ask window to give us events even if outside the view
    SetCapture();

  //  save the current mouse coordinate in min 
  myXmin=point.x;  myYmin=point.y;
  myXmax=point.x;  myYmax=point.y;

  if ( nFlags & CASCADESHORTCUTKEY ) 
	  {
	    // Button MB1 down Control :start zomming 
	    myCurrentMode = CurAction3d_DynamicZooming;
	  }
	else // if ( Ctrl )
	  {
        switch (myCurrentMode)
        {
         case CurAction3d_Nothing : // start a drag
                DragEvent(myXmax,myYmax,-1);
        break;
         break;
         case CurAction3d_DynamicZooming  : // noting
         break;
         case CurAction3d_WindowZooming   : // noting
         break;
         case CurAction3d_DynamicPanning  : // noting
         break;
         case CurAction3d_GlobalPanning   : // noting
        break;
        case  CurAction3d_DynamicRotation :
			if (!myDegenerateModeIsOn)
			  myView->SetDegenerateModeOn();
			myView->StartRotation(point.x,point.y);  
        break;
        default :
           Standard_Failure::Raise(" incompatible Current Mode ");
        break;
        }
    }

    
    // ask window to no longer give us events even if outside the view
//	ReleaseCapture();

}

void CMatsuuraView::OnLButtonUp(UINT nFlags, CPoint point) 
{
    // check the current window ( could be another one if draging )

    switch (myCurrentMode)
    {
     case CurAction3d_Nothing :
     if (point.x == myXmin && point.y == myYmin)
     { // no offset between down and up --> selectEvent
        myXmax=point.x;   myYmax=point.y;
          InputEvent     (point.x,point.y);
     } else
     {
        myXmax=point.x;  myYmax=point.y;
        DrawRectangle(Standard_False);
			DragEvent(point.x,point.y,1);
     }
     break;
     case CurAction3d_DynamicZooming :
	   myCurrentMode = CurAction3d_Nothing;
     break;
     case CurAction3d_WindowZooming :
       myXmax=point.x;       myYmax=point.y;
       DrawRectangle(Standard_False);
	   if ((abs(myXmin-myXmax)>ValZWMin) || (abs(myYmin-myYmax)>ValZWMin))
				 // Test if the zoom window is greater than a minimale window.
		{
		  // Do the zoom window between Pmin and Pmax
		  myView->WindowFitAll(myXmin,myYmin,myXmax,myYmax);  
		}  
	   myCurrentMode = CurAction3d_Nothing;
     break;
     case CurAction3d_DynamicPanning :
       myCurrentMode = CurAction3d_Nothing;
     break;
     case CurAction3d_GlobalPanning :
	   myView->Place(point.x,point.y,myCurZoom); 
	   myCurrentMode = CurAction3d_Nothing;
    break;
    case  CurAction3d_DynamicRotation :
	   myCurrentMode = CurAction3d_Nothing;
	   if (!myDegenerateModeIsOn)
		{  
		  CWaitCursor aWaitCursor;
		  myView->SetDegenerateModeOff();
		  myDegenerateModeIsOn = Standard_False;
		} else
		{
		  myView->SetDegenerateModeOn();
		  myDegenerateModeIsOn = Standard_True;
		}

    break;
    default :
       Standard_Failure::Raise(" incompatible Current Mode ");
    break;
    } //switch (myCurrentMode)

    // ask window to no longer give us events even if outside the view

	ReleaseCapture();
}

void CMatsuuraView::OnMButtonDown(UINT nFlags, CPoint point) 
{
    // ask window to give us events even if outside the view
//    SetCapture();

   if ( nFlags & CASCADESHORTCUTKEY ) 
	  {
      	// Button MB2 down Control : panning init  
	  }
}

void CMatsuuraView::OnMButtonUp(UINT nFlags, CPoint point) 
{
    // check the current window ( could be another one if draging )
//	if (GetCapture() != this) return;


   if ( nFlags & CASCADESHORTCUTKEY ) 
	  {
      	// Button MB2 down Control : panning init  
	  }
    // ask window to no longer give us events even if outside the view
//	ReleaseCapture();
}

void CMatsuuraView::OnRButtonDown(UINT nFlags, CPoint point) 
{
    // ask window to give us events even if outside the view
//    SetCapture();

   if ( nFlags & CASCADESHORTCUTKEY ) 
	  {
	    if (!myDegenerateModeIsOn)
	      myView->SetDegenerateModeOn();
	    myView->StartRotation(point.x,point.y);  
	  }
	else // if ( CASCADESHORTCUTKEY )
	  {
#ifdef POPUPONBUTTONDOWN
	    Popup(point.x,point.y);
#endif	
      }	
}

void CMatsuuraView::OnRButtonUp(UINT nFlags, CPoint point) 
{
    // reset tyhe good Degenerated mode according to the strored one
    //   --> dynamic rotation may have change it 
    if (!myDegenerateModeIsOn)
    {  
      CWaitCursor aWaitCursor;
      myView->SetDegenerateModeOff();
      myDegenerateModeIsOn = Standard_False;
    } else
    {
      myView->SetDegenerateModeOn();
      myDegenerateModeIsOn = Standard_True;

    }
#ifndef POPUPONBUTTONDOWN
   if ( !(nFlags & CASCADESHORTCUTKEY) ) 
	    Popup(point.x,point.y);
#endif
}

void CMatsuuraView::OnMouseMove(UINT nFlags, CPoint point) 
{
    // check the current window ( could be another one if draging )
//	if (GetCapture() != this) return;

    //   ============================  LEFT BUTTON =======================
  if ( (nFlags & MK_LBUTTON) && !(nFlags & MK_RBUTTON) )
    {
		switch (myCurrentMode)
		{
		 case CurAction3d_Nothing :
		   DrawRectangle(Standard_False);
		   myXmax = point.x;      myYmax = point.y;
			 DragEvent(myXmax,myYmax,0);
		   DrawRectangle(Standard_True);
		  break;
		 case CurAction3d_DynamicZooming :
		   myView->Zoom(myXmax,myYmax,point.x,point.y); 
		   // save the current mouse coordinate in min \n";
		   myXmax=point.x;  myYmax=point.y;
		 break;
		 case CurAction3d_WindowZooming :
		   myXmax = point.x; myYmax = point.y;	
		   DrawRectangle(Standard_True,LongDash);
		 break;
		 case CurAction3d_DynamicPanning :
		   myView->Pan(point.x-myXmax,myYmax-point.y); // Realize the panning
		   myXmax = point.x; myYmax = point.y;	
		 break;
		 case CurAction3d_GlobalPanning : // nothing           
		break;
		case  CurAction3d_DynamicRotation :
		  myView->Rotation(point.x,point.y);
		  myView->Redraw();
		break;
		default :
		   Standard_Failure::Raise(" incompatible Current Mode ");
		break;
		}//  switch (myCurrentMode)
    } else //   if ( nFlags & MK_LBUTTON) 
    //   ============================  MIDDLE BUTTON =======================
    if ( (nFlags & MK_MBUTTON) || ((nFlags & MK_LBUTTON) && (nFlags & MK_RBUTTON) ))
    {
     if ( nFlags & CASCADESHORTCUTKEY ) 
	  {
		myView->Pan(point.x-myXmax,myYmax-point.y); // Realize the panning
		myXmax = point.x; myYmax = point.y;	
	  }
    } else //  if ( nFlags & MK_MBUTTON)
    //   ============================  RIGHT BUTTON =======================

    if ( (nFlags & MK_RBUTTON)&& !(nFlags & MK_LBUTTON) )
    {
     if ( nFlags & CASCADESHORTCUTKEY ) 
	  {
      	 myView->Rotation(point.x,point.y);
	  }
    }else //if ( nFlags & MK_RBUTTON)
    //   ============================  NO BUTTON =======================
    {  // No buttons 
	  myXmax = point.x; myYmax = point.y;	
		MoveEvent(point.x,point.y);
   }
	//ligne pour eviter un bug de mise a jour avec certaines cartes graphiques
	if (GetDocument()->GetAISContext()->HasOpenedContext())
		myView->Redraw();
}

void CMatsuuraView::DrawRectangle(const Standard_Boolean  Draw , 
                                        const LineStyle aLineStyle)
{
    static int m_DrawMode=R2_MERGEPENNOT;
    static		Standard_Integer StoredMinX, StoredMaxX, StoredMinY, StoredMaxY;
    static		Standard_Boolean m_IsVisible=Standard_False;
    static  StoredLineStyle= aLineStyle;

    CPen* aOldPen;
    CClientDC clientDC(this);
    if (m_Pen) aOldPen = clientDC.SelectObject(m_Pen);
    clientDC.SetROP2(m_DrawMode);

    if ( m_IsVisible ) //  erase at the old position 
    {
     clientDC.MoveTo(StoredMinX,StoredMinY); clientDC.LineTo(StoredMinX,StoredMaxY); 
     clientDC.LineTo(StoredMaxX,StoredMaxY); 
	 clientDC.LineTo(StoredMaxX,StoredMinY); clientDC.LineTo(StoredMinX,StoredMinY);
     m_IsVisible = Standard_False;
    }

    StoredMinX = min ( myXmin, myXmax );    StoredMinY = min ( myYmin, myYmax );
    StoredMaxX = max ( myXmin, myXmax );    StoredMaxY = max ( myYmin, myYmax);

    if (Draw){ // move : draw
        if (StoredLineStyle != aLineStyle) {
            delete m_Pen;
            if  (aLineStyle ==Solid )
                {m_Pen = new CPen(PS_SOLID, 2, RGB(0,0,0)); m_DrawMode = R2_MERGEPENNOT;}
            else if (aLineStyle ==Dot )
                {m_Pen = new CPen(PS_DOT, 1, RGB(0,0,0));   m_DrawMode = R2_XORPEN;}
            else if (aLineStyle == ShortDash)
                {m_Pen = new CPen(PS_DASH, 1, RGB(255,0,0));	m_DrawMode = R2_XORPEN;}
            else if (aLineStyle == LongDash)
                {m_Pen = new CPen(PS_DASH, 1, RGB(0,0,0));	m_DrawMode = R2_NOTXORPEN;}
            clientDC.SelectObject(m_Pen);
        }

     clientDC.SetROP2(m_DrawMode);
     clientDC.MoveTo(StoredMinX,StoredMinY); clientDC.LineTo(StoredMinX,StoredMaxY); 
     clientDC.LineTo(StoredMaxX,StoredMaxY); 
	 clientDC.LineTo(StoredMaxX,StoredMinY); clientDC.LineTo(StoredMinX,StoredMinY);
     m_IsVisible = Standard_True;
   }

    if (m_Pen) clientDC.SelectObject(aOldPen);
}


void CMatsuuraView::OnUpdateBUTTONHlrOff(CCmdUI* pCmdUI) 
{
    pCmdUI->SetCheck (myDegenerateModeIsOn);
	pCmdUI->Enable   (!myDegenerateModeIsOn);	
}

void CMatsuuraView::OnUpdateBUTTONHlrOn(CCmdUI* pCmdUI) 
{
    pCmdUI->SetCheck (!myDegenerateModeIsOn);
	pCmdUI->Enable   (myDegenerateModeIsOn);	
}

void CMatsuuraView::OnUpdateBUTTONPanGlo(CCmdUI* pCmdUI) 
{
    pCmdUI->SetCheck (myCurrentMode == CurAction3d_GlobalPanning);
	pCmdUI->Enable   (myCurrentMode != CurAction3d_GlobalPanning);	
	
}

void CMatsuuraView::OnUpdateBUTTONPan(CCmdUI* pCmdUI) 
{
    pCmdUI->SetCheck (myCurrentMode == CurAction3d_DynamicPanning);
	pCmdUI->Enable   (myCurrentMode != CurAction3d_DynamicPanning );	
}

void CMatsuuraView::OnUpdateBUTTONZoomProg(CCmdUI* pCmdUI) 
{
    pCmdUI->SetCheck (myCurrentMode == CurAction3d_DynamicZooming );
	pCmdUI->Enable   (myCurrentMode != CurAction3d_DynamicZooming);	
}

void CMatsuuraView::OnUpdateBUTTONZoomWin(CCmdUI* pCmdUI) 
{
    pCmdUI->SetCheck (myCurrentMode == CurAction3d_WindowZooming);
	pCmdUI->Enable   (myCurrentMode != CurAction3d_WindowZooming);	
}

void CMatsuuraView::OnUpdateBUTTONRot(CCmdUI* pCmdUI) 
{
    pCmdUI->SetCheck (myCurrentMode == CurAction3d_DynamicRotation);
	pCmdUI->Enable   (myCurrentMode != CurAction3d_DynamicRotation);	
}



void CMatsuuraView::OnChangeBackground() 
{
	Standard_Real R1;
	Standard_Real G1;
	Standard_Real B1;
    myView->BackgroundColor(Quantity_TOC_RGB,R1,G1,B1);
	COLORREF m_clr ;
	m_clr = RGB(R1*255,G1*255,B1*255);

	CColorDialog dlgColor(m_clr);
	if (dlgColor.DoModal() == IDOK)
	{
		m_clr = dlgColor.GetColor();
		R1 = GetRValue(m_clr)/255.;
		G1 = GetGValue(m_clr)/255.;
		B1 = GetBValue(m_clr)/255.;
        myView->SetBackgroundColor(Quantity_TOC_RGB,R1,G1,B1);
	}
    myView->Redraw();
}

//-----------------------------------------------------------------------------------------
void CMatsuuraView::InputEvent(const Standard_Integer  x     ,
				                   const Standard_Integer  y     ) 
{
	CMatsuuraDoc *pDoc=GetDocument();

	Handle_AIS_InteractiveContext IC=pDoc->GetAISContext(); 
	IC->Select();
	
	// on considere le premier object selectionne
	for(IC->InitSelected(); IC->MoreSelected(); IC->NextSelected)
	{
		//l'object selectionne (= une face) devient un object topologique S puis F
		Handle_AIS_InteractiveObject IO=IC->Interactive();
		if (IO->IsKind(STANDARD_TYPE(AIS_Trihedron)))
		{
			IC->ClearSelected();
			break;
		}
		TopoDS_Shape S = IC->SelectedShape();
		if (S.ShapeType()==TopAbs_FACE)
		{
			if (pDoc->SurfType==COMPLEX_FACE)
			{
				IC->ActivateStandardMode(TopAbs_EDGE);
				pDoc->AddComplexFace(TopoDS::Face(S));
			}
			else
				pDoc->AddSimpleFace(TopoDS::Face(S));

		}
		else if (S.ShapeType()==TopAbs_EDGE)
			pDoc->AddComplexEdge(TopoDS::Edge(S));
		break;
	}
}

void CMatsuuraView::DragEvent(const Standard_Integer  x        ,
				                  const Standard_Integer  y        ,
				                  const Standard_Integer  TheState )
{
    // TheState == -1  button down
	// TheState ==  0  move
	// TheState ==  1  button up

    static Standard_Integer theButtonDownX=0;
    static Standard_Integer theButtonDownY=0;

	if (TheState == -1)
    {
      theButtonDownX=x;
      theButtonDownY=y;
    }

	if (TheState == 0)
	  GetDocument()->GetAISContext()->Select(theButtonDownX,theButtonDownY,x,y,myView);  

}

//-----------------------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------------------
void CMatsuuraView::MoveEvent(const Standard_Integer  x       ,
                                  const Standard_Integer  y       ) 
{
	GetDocument()->GetAISContext()->MoveTo(x,y,myView);
}

void  CMatsuuraView::Popup(const Standard_Integer  x,
							   const Standard_Integer  y ) 
{
  Standard_Integer PopupMenuNumber=0;
  const Handle(AIS_InteractiveContext)& theContext=GetDocument()->GetAISContext();
  for(theContext->InitCurrent();
      theContext->MoreCurrent();
      theContext->NextCurrent())
    if (theContext->DisplayStatus(theContext->Current()) == AIS_DS_Displayed)
    PopupMenuNumber=1;

  CMenu menu;
  VERIFY(menu.LoadMenu(IDR_Popup3D));
  CMenu* pPopup = menu.GetSubMenu(PopupMenuNumber);

  ASSERT(pPopup != NULL);
  theContext->InitCurrent(); 
  if (PopupMenuNumber == 1) // more than 1 object.
  {

    }
  

  POINT winCoord = { x , y };
  ClientToScreen ( &winCoord);
  pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON , winCoord.x, winCoord.y , 
                         AfxGetMainWnd());

}

void CMatsuuraView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	myView->FitAll();
}

void CMatsuuraView::OnTimer(UINT nIDEvent) 
{
	if (up==true)
		OnUp();
	else
		OnDown();

	CView::OnTimer(nIDEvent);
}

void CMatsuuraView::OnDown() 
{
	CMatsuuraDoc *pDoc=GetDocument();

	pDoc->NumCurPos--;
	if (!pDoc->OnStep())
		OnStop();
}

void CMatsuuraView::OnUp() 
{
	CMatsuuraDoc *pDoc=GetDocument();

	pDoc->NumCurPos++;
	if (!pDoc->OnStep())
		OnStop();
}

void CMatsuuraView::OnFirst() 
{
	GetDocument()->NumCurPos=GetDocument()->nb_Coord;	
	OnUp();
}

void CMatsuuraView::OnLast() 
{
	GetDocument()->NumCurPos=-1;
	OnUp();
}

void CMatsuuraView::OnPlayDown() 
{
	KillTimer(1);
	SetTimer(1,delay,NULL);
	up=false;
	down=true;
}

void CMatsuuraView::OnPlayUp() 
{
	KillTimer(1);
	SetTimer(1,delay,NULL);
	up=true;
	down=false;
}

void CMatsuuraView::OnStop() 
{
	KillTimer(1);
	up=down=false;
}


void CMatsuuraView::OnUpdateStop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(GetDocument()->computed);	
}

void CMatsuuraView::OnUpdateDown(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(GetDocument()->computed);	
	
}

void CMatsuuraView::OnUpdateFirst(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(GetDocument()->computed);	
	
}

void CMatsuuraView::OnUpdateLast(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(GetDocument()->computed);	
	
}

void CMatsuuraView::OnUpdatePlayDown(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(GetDocument()->computed);	
	
}

void CMatsuuraView::OnUpdatePlayUp(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(GetDocument()->computed);	
	
}

void CMatsuuraView::OnUpdateUp(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(GetDocument()->computed);	
	
}
