// MatsuuraView.h : interface of the CMatsuuraView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MatsuuraVIEW_H__82080FEC_54D0_42CB_B37E_E331773B42FD_3D_INCLUDED_)
#define AFX_MatsuuraVIEW_H__82080FEC_54D0_42CB_B37E_E331773B42FD_3D_INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CMatsuuraView : public CView
{
protected: // create from serialization only
	CMatsuuraView();
	DECLARE_DYNCREATE(CMatsuuraView)

// Attributes
public:
	CMatsuuraDoc* GetDocument();

	bool up;
	bool down;

	int delay;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMatsuuraView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate(); // CasCade
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMatsuuraView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
public:
	//{{AFX_MSG(CMatsuuraView)
	afx_msg void OnBUTTONAxo();
	afx_msg void OnBUTTONBack();
	afx_msg void OnBUTTONBottom();
	afx_msg void OnBUTTONFront();
	afx_msg void OnBUTTONLeft();
	afx_msg void OnBUTTONPan();
	afx_msg void OnBUTTONPanGlo();
	afx_msg void OnBUTTONReset();
	afx_msg void OnBUTTONRight();
	afx_msg void OnBUTTONRot();
	afx_msg void OnBUTTONTop();
	afx_msg void OnBUTTONZoomAll();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBUTTONZoomProg();
	afx_msg void OnBUTTONZoomWin();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnUpdateBUTTONHlrOff(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBUTTONHlrOn(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBUTTONPanGlo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBUTTONPan(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBUTTONZoomProg(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBUTTONZoomWin(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBUTTONRot(CCmdUI* pCmdUI);
	afx_msg void OnChangeBackground();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDown();
	afx_msg void OnFirst();
	afx_msg void OnLast();
	afx_msg void OnStop();
	afx_msg void OnUp();
	afx_msg void OnPlayDown();
	afx_msg void OnPlayUp();
	afx_msg void OnUpdateStop(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDown(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFirst(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLast(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePlayDown(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePlayUp(CCmdUI* pCmdUI);
	afx_msg void OnUpdateUp(CCmdUI* pCmdUI);

	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
protected:
	Handle(V3d_View)     myView;
public:
	Handle(V3d_View)&    GetView() { return myView;};
protected:
	bool FirsTime;
    CurrentAction3d      myCurrentMode;
    Standard_Integer     myXmin;
    Standard_Integer     myYmin;  
    Standard_Integer     myXmax;
    Standard_Integer     myYmax;
    Quantity_Factor      myCurZoom;
    Standard_Boolean     myDegenerateModeIsOn;

    virtual void DragEvent      (const Standard_Integer  x       ,
	    			     const Standard_Integer  y       ,
		    		     const Standard_Integer  TheState);
    virtual void InputEvent     (const Standard_Integer  x       ,
	    			     const Standard_Integer  y       );  
    virtual void MoveEvent      (const Standard_Integer  x       ,
                         const Standard_Integer  y       ); 
    virtual void Popup          (const Standard_Integer  x       ,
		    			 const Standard_Integer  y       ); 


private:
	enum LineStyle { Solid, Dot, ShortDash, LongDash };
	CPen*  m_Pen;
    virtual void DrawRectangle (const Standard_Boolean  Draw =Standard_True,
                                const LineStyle aLineStyle = Solid  );

};

#ifndef _DEBUG  // debug version in MatsuuraView.cpp
inline CMatsuuraDoc* CMatsuuraView::GetDocument()
   { return (CMatsuuraDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MatsuuraVIEW_H__82080FEC_54D0_42CB_B37E_E331773B42FD_3D_INCLUDED_)
