// Options.cpp : implementation file
//

#include "stdafx.h"
#include "matsuura.h"
#include "Options.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptions dialog


COptions::COptions(CurMethod_ M)
	: CDialog(COptions::IDD, NULL)
{
	//{{AFX_DATA_INIT(COptions)
	m_Delay = 0;
	m_Precision = 0.0;
	m_Discret = 0;
	m_MaxIter = 0;
	m_MAD = 0.0;
	m_WFo = 0.0;
	m_WFc = 0.0;
	//}}AFX_DATA_INIT
	Method=M;
}


void COptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions)
	DDX_Text(pDX, IDC_DELAY, m_Delay);
	DDX_Text(pDX, IDC_EDIT_PRECISION, m_Precision);
	DDX_Text(pDX, IDC_EDIT_DISCRET, m_Discret);
	DDX_Text(pDX, IDC_EDIT_MAX_ITER, m_MaxIter);
	DDX_Text(pDX, IDC_EDIT_MAD, m_MAD);
	DDX_Text(pDX, IDC_EDIT_WFo, m_WFo);
	DDX_Text(pDX, IDC_EDIT_WFc, m_WFc);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions, CDialog)
	//{{AFX_MSG_MAP(COptions)
	ON_BN_CLICKED(IDC_RADIO_MGI, OnRadioMgi)
	ON_BN_CLICKED(IDC_RADIO_RMR, OnRadioRmr)
	ON_BN_CLICKED(IDC_RADIO_RMROPT, OnRadioRmropt)
	ON_EN_CHANGE(IDC_EDIT_WFo, OnChangeEDITWFo)
	ON_BN_CLICKED(IDC_BUTTON_HELP_CRITERIA1, OnButtonHelpCriteria1)
	ON_BN_CLICKED(IDC_BUTTON_HELP_CRITERIA2, OnButtonHelpCriteria2)
	ON_BN_CLICKED(IDC_RADIO_CRITERIA1, OnRadioCriteria1)
	ON_BN_CLICKED(IDC_RADIO_CRITERIA2, OnRadioCriteria2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptions message handlers

BOOL COptions::OnInitDialog() 
{
	m_WFc=100-m_WFo;
	CDialog::OnInitDialog();
	
	if (Criteria==GLOBAL_CRITERIA)
		((CButton*)GetDlgItem(IDC_RADIO_CRITERIA1))->SetCheck(true);
	else
		((CButton*)GetDlgItem(IDC_RADIO_CRITERIA2))->SetCheck(true);


	if (Method==RMR_METHOD)
	{
		((CButton*)GetDlgItem(IDC_RADIO_RMR))->SetCheck(true);
		GetDlgItem(IDC_EDIT_MAD)->EnableWindow(false);
		GetDlgItem(IDC_EDIT_WFo)->EnableWindow(false);
		GetDlgItem(IDC_RADIO_CRITERIA1)->EnableWindow(false);
		GetDlgItem(IDC_RADIO_CRITERIA2)->EnableWindow(false);
	}
	else if (Method==RMROPT_METHOD)
		((CButton*)GetDlgItem(IDC_RADIO_RMROPT))->SetCheck(true);
	else
	{
		((CButton*)GetDlgItem(IDC_RADIO_MGI))->SetCheck(true);
		GetDlgItem(IDC_EDIT_PRECISION)->EnableWindow(false);
		GetDlgItem(IDC_EDIT_MAX_ITER)->EnableWindow(false);
		GetDlgItem(IDC_EDIT_MAD)->EnableWindow(false);
		GetDlgItem(IDC_EDIT_WFo)->EnableWindow(false);
		GetDlgItem(IDC_RADIO_CRITERIA1)->EnableWindow(false);
		GetDlgItem(IDC_RADIO_CRITERIA2)->EnableWindow(false);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptions::OnRadioMgi() 
{
	Method=MGI_METHOD;
	GetDlgItem(IDC_EDIT_PRECISION)->EnableWindow(false);
	GetDlgItem(IDC_EDIT_MAX_ITER)->EnableWindow(false);
	GetDlgItem(IDC_EDIT_MAD)->EnableWindow(false);
	GetDlgItem(IDC_EDIT_WFo)->EnableWindow(false);
	GetDlgItem(IDC_RADIO_CRITERIA1)->EnableWindow(false);
	GetDlgItem(IDC_RADIO_CRITERIA2)->EnableWindow(false);
}

void COptions::OnRadioRmr() 
{
	Method=RMR_METHOD;
	GetDlgItem(IDC_EDIT_PRECISION)->EnableWindow(true);
	GetDlgItem(IDC_EDIT_MAX_ITER)->EnableWindow(true);
	GetDlgItem(IDC_EDIT_MAD)->EnableWindow(false);
	GetDlgItem(IDC_EDIT_WFo)->EnableWindow(false);
	GetDlgItem(IDC_RADIO_CRITERIA1)->EnableWindow(false);
	GetDlgItem(IDC_RADIO_CRITERIA2)->EnableWindow(false);
}

void COptions::OnRadioRmropt() 
{
	Method=RMROPT_METHOD;
	GetDlgItem(IDC_EDIT_PRECISION)->EnableWindow(true);
	GetDlgItem(IDC_EDIT_MAX_ITER)->EnableWindow(true);
	GetDlgItem(IDC_EDIT_MAD)->EnableWindow(true);
	GetDlgItem(IDC_EDIT_WFo)->EnableWindow(true);
	GetDlgItem(IDC_RADIO_CRITERIA1)->EnableWindow(true);
	GetDlgItem(IDC_RADIO_CRITERIA2)->EnableWindow(true);
}

void COptions::OnChangeEDITWFo() 
{
	UpdateData();
	m_WFc=100-m_WFo;
	UpdateData(false);
}

void COptions::OnButtonHelpCriteria1() 
{
	AfxMessageBox("This criteria tries to reach the mean \
articular positions of the machine (i.e. in the global axis)");	
}

void COptions::OnButtonHelpCriteria2() 
{
	AfxMessageBox("This criteria tries to reach the mean \
articular positions of the machine in the context of the milling\
of this part (i.e. in the part axis)");	
}

void COptions::OnRadioCriteria1() 
{
	Criteria=GLOBAL_CRITERIA;	
}

void COptions::OnRadioCriteria2() 
{
	Criteria=LOCAL_CRITERIA;	
}
